#include "Image.h"
#include <qfile.h>
#include <qdragobject.h>
#include <qprinter.h>
#include <qmessagebox.h>
Image::Image(QWidget* parent,const char* name):QWidget( parent, name ) {
//initMetaObject();

resize(200,200);

qp=new QPainter();
qpm=new QPixmap(size());
qpd=NULL;

datar=dcopy=NULL;

setBackgroundMode(NoBackground);

shapes.setAutoDelete(TRUE);
lscale=1.0;

mtstr="No Image";

setCursor(crossCursor);

mode=0;
cont=0;
brite=0;
needupd=1;
scale=0;
invert=0;
originx=originy=0;
showfft=0;
imc=NULL;
}

Image::~Image() {
if (imc) delete imc;
delete qp;
delete qpm;
}

void Image::resizeEvent ( QResizeEvent *qe ) {
qp->begin(this);
qp->eraseRect(qp->window());
qp->end();
if (!datar) return;

qpm->resize(size().width(),size().height());
needupd=1;
emit(resized(size().width(),size().height()));
}

void Image::paintEvent( QPaintEvent *pe ) {
char *d;
float mm,b,me;
int i,sx,sy;
ImShape *cur;
EMData *data = datar;
if (datar && showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

//sz=width()<height()?width():height();
sx=qpm->width();
sy=qpm->height();
if (data && scale==0) {
	lscale=(float)sy/(data->ySize()-.5);
	originx=originy=0;
}
else lscale=scale;

if (!data) {
	qp->begin(this);
	qp->fillRect(0,0,size().width(),size().height(),white);
	qp->setPen(black);
	qp->drawText(0,0,size().width(),size().height(),AlignCenter,mtstr.data());
	qp->end();
//	printf(" NULL\n");
	return;
}
else if (needupd||qpd) {
	if (data->zSize()==1) {

//		mm=-data->Min()<data->Max()?data->Max():-data->Min();
//		b=mm*brite;
//	    mm*=(1.0-sqrt(cont));

		mm=(data->Max()-data->Min())/2.0;
		me=(data->Max()+data->Min())/2.0;
		b=mm*brite*2.0;
		mm*=(1.0-sqrt(cont));

		d=(char *)malloc(sx*sy+80);
		memset(d,127,sx*sy+80);

		sprintf(d,"P5\n%d %d\n255\n",sx,sy);
		i=strlen(d);
//		data->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
//			lscale,invert?254:1,invert?1:254,-mm-b,mm-b);
		data->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
			lscale,invert?254:1,invert?1:254,me-mm-b,me+mm-b);

		if (imc) imc->imageMinMax(me-mm-b,me+mm-b);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy));

//pr->renderAmp8((unsigned char *)d+i,0,0,width(),height(),width(),
//	scale,1,254,-mm-b,mm-b);

/*QFile out("abc.pgm");
out.open(IO_WriteOnly);
out.writeBlock(d,(i+height()*width()));
out.close();*/

		free(d);
		needupd=0;
//printf("%d,%d  %d,%d\n",size().width(),size().height(),qpm->size().width(),qpm->size().height());
	}
	else if (dcopy) {
		EMData *pr;
		
		if (mode) {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-3,(brite+1.0)*dcopy->Max()/2.0);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
//			b=mm*brite;
			mm*=(1.0-cont);
		} else {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-2);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
			b=mm*brite;
			mm*=(1.0-cont);
		}

		d=(char *)malloc(sx*sy+80);
		memset(d,0,sx*sy+80);

		sprintf(d,"P5\n%d %d\n255\n",sx,sy);
		i=strlen(d);
		if (pr->isComplex()) pr->ri2ap();
		pr->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
			lscale,invert?254:1,invert?1:254,-mm-b,mm-b);

		if (imc) imc->imageMinMax(-mm-b,mm-b);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy));

		free(d);
		needupd=0;
	}
}

if (shapes.count()==0 && select.type==ImShape::NONE) bitBlt( this, 0,0, qpm );
else {
//	QPixmap qpm2(*qpm);

//	qp->begin(&qpm2);
//	bitBlt( this, 0,0, qpm );
	bitBlt( this,pe->rect().topLeft(),qpm,pe->rect());
	qp->begin(this);
	qp->setPen(red);

	shapes.append(&select);
	for (cur=shapes.first(); cur!=NULL; cur=shapes.next()) {
//printf("%d %d  %d %d\n",cur->x0,cur->y0,dxtopx(cur->x0),dytopy(cur->y0));

		qp->setPen(QPen(cur->color,cur->lw));
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(QBrush(cur->color,SolidPattern));
		switch(cur->type) {
		case ImShape::LINE:
			qp->drawLine(dxtopx(cur->x0),dytopy(cur->y0),dxtopx(cur->x1),dytopy(cur->y1));
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				if (cur->y1>cur->y0) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
				else qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)-5,cur->text);
				qp->setPen(red);
			}
			break;
		case ImShape::DOTBOX:
			qp->drawEllipse(dxtopx(cur->x0+cur->x1/2)-1,dytopy(cur->y0+cur->y1/2)-1,3,3);
		case ImShape::BOX:
			qp->drawRect(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
			}
			break;
		case ImShape::CIRCLE:
		case ImShape::FILL_CIRCLE:
			qp->drawEllipse(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			break;
		//centered ellipse, x0 is major radius, y0 is minor radius, userf is angle in degrees
		case ImShape::CENELLIPSE:
			if (data) qp->translate(dxtopx(data->xSize()/2),dytopy(data->ySize()/2));
			else qp->translate(width()/2,height()/2);
			qp->rotate(-cur->userf);
			qp->drawEllipse(-cur->x0,-cur->y0,cur->x0*2,cur->y0*2);
			qp->resetXForm();
//			printf("cene %d %d %1.2f \n",cur->x0,cur->y0,cur->userf);
			break;
		case ImShape::TEXT:
			if (!cur->text.isEmpty()) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0),cur->text);
			break;
		}
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(NoBrush);
	}
	shapes.last();
	shapes.take();
	qp->end();

//	bitBlt( this, 0,0, &qpm2 );
}

}

float Image::pxtodx(int px) {
return ((px+originx-1)/lscale+.5);
}

float Image::pytody(int py) {
return ((height()-py+originy)/lscale)+.5;
}

int Image::dxtopx(int dx) {
return (int)(dx*lscale-originx-lscale/2+1);
}

int Image::dytopy(int dy) {
return (int)(-(dy*lscale-originy-height())+lscale/2);
}


void Image::print(QPaintDevice *dev) {
int x,y;

update();
}

void Image::setData(EMData *d) {
char s[140];

datar=d; 
if (!d) { imageChanged(); return; }
if (d && datar->ufloat==0) datar->ufloat=datar->Max();

if (dcopy) { delete dcopy; dcopy=NULL; }
if (d && d->zSize()>1) dcopy=datar->copy();

strncpy(s,d->Path(),100);
s[100]=0;
strcat(s," (middle mouse for controls)");
setCaption(s);
qpm->resize(size().width(),size().height());

/*if (d->isComplex() && brite==0 && cont==0) {
	brite=.5;
	cont=.33;
}*/
imageChanged();
}

void Image::mouseDoubleClickEvent(QMouseEvent *e) { };

void Image::mouseEnter(int) { };

void Image::mouseLeave(int) { };

void Image::keyPressEvent(QKeyEvent *) { };

void Image::keyReleaseEvent(QKeyEvent *) { };

void Image::mousePressEvent(QMouseEvent *e) {
if (!datar) return;
int x,y;
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

if ((e->button()&LeftButton)) {
	if ((e->state()&ShiftButton) && qpm) {
		
		QImageDrag *idr = new QImageDrag(qpm->convertToImage(),this);
		if (idr) idr->dragCopy();
		else printf("Drag error\n");
	}
	else emit(mousePress(e));
}
/*if ((e->button()&MidButton)) { 
	invert^=1; 
	if (imc) imc->setup(brite,cont,invert,-1); 
	needupd=1; 
	update(); 
}*/
/*if ((e->button()&RightButton) && data && (e->state()&ShiftButton)) { 
	mode^=1; 
	needupd=1; 
	update(); 
}
else*/ 
if ((e->button()&MidButton) || (e->button()&LeftButton && e->state()&ControlButton)) {
	if ((e->state()&ShiftButton) && qpm) {
		mode^=1; 
		needupd=1; 
		update(); 
	}
	else {
		if (!imc) {	
			imc=new ImageMxCon; 
			connect(imc,SIGNAL(setBC(float,float)),SLOT(setBC(float,float)));
			connect(imc,SIGNAL(invToggle(int)),SLOT(setInvert(int)));
			connect(imc,SIGNAL(fftToggle(int)),SLOT(setFFT(int)));
			connect(imc,SIGNAL(saveImage()),SLOT(saveImage()));
			connect(imc,SIGNAL(setScale(float)),SLOT(setScale(float)));
			connect(imc,SIGNAL(print()),SLOT(doPrint()));
			connect(imc,SIGNAL(newMode(int)),SLOT(setMode(int)));
			connect(this,SIGNAL(imChanged(EMData *)),imc,SLOT(imageChanged(EMData *)));
			connect(this,SIGNAL(probe(unsigned char *,int,int,int,float)),imc,SLOT(doProbe(unsigned char *,int,int,int,float)));
			imc->setup(brite,cont,invert,-1,-1);
		}
		imc->show();
		imc->raise();
		emit imChanged(data);
		needupd=1;
		update();
	}
}

mdx=e->x();
mdy=e->y();

}

void Image::doPrint() {
QPrinter pr;
pr.setup();
QPainter pa(&pr);

pa.drawPixmap(0,0,*qpm);
pa.end();
}

void Image::saveImage() {
QString s1( QFileDialog::getSaveFileName(getenv("PWD"),"*.png") );
if ( s1.isNull() ) return;

qpm->save(s1.data(),"PNG");
}

void Image::setBC(float b,float c) { cont=c; brite=b; needupd=1; update();}

void Image::setInvert(int i) { invert=i; needupd=1; update(); }

void Image::setFFT(int i) { 
if (i && (datar->getFlags()&EMDATA_NEWFFT) && datar->xSize()*datar->ySize()>2000000 && 
	QMessageBox::warning(this,"BIG IMAGE",
	"This is a pretty large image\n\nAre you sure you want me to do a FFT?","Yes","No")) return;
if (i && (datar->getFlags()&EMDATA_NEWFFT) && datar->xSize()!=datar->ySize() && 
	QMessageBox::warning(this,"NOT SQUARE",
	"This image isn't square\n\nAre you sure you want me to do a FFT?","Yes","No")) return;
showfft=i; 
imageChanged();
}

void Image::notVisible() { if (imc) imc->hide(); }

void Image::mouseReleaseEvent(QMouseEvent *e) {
int *a,b;

if ((e->button()&LeftButton)) emit(mouseRelease(e));

mdx=e->x();
mdy=e->y();

}

void Image::mouseMoveEvent(QMouseEvent *e) {
if (!datar) return;

int x,y,sz,nx;
float *d,az,r,a=0,c=0,scale;
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

x=e->x();
y=e->y();

if ((e->state()&LeftButton) && data) {
	if (!(e->state()&ShiftButton)) {
		if (mode==4) {
			unsigned char mx[49];
			float mm,me,b;
			mm=(data->Max()-data->Min())/2.0;
			me=(data->Max()+data->Min())/2.0;
			b=mm*brite*2.0;
			mm*=(1.0-sqrt(cont));
			memset(mx,0,49);

			x=pxtodx(x);
			y=pytody(y);
//			data->renderAmp8(mx,x+originx/lscale-3,y+originy/lscale-3,7,7,7,1.0,invert?254:1,invert?1:254,me-mm-b,me+mm-b);
//			emit probe(mx,x+originx/lscale,y+originy/lscale,data->valueAt(x+originx/lscale,y+originy/lscale));
			data->renderAmp8(mx,x-3,y-3,7,7,7,1.0,invert?254:1,invert?1:254,me-mm-b,me+mm-b);
			if (data->isComplex()) {
				int x1 = x-data->xSize()/2+1;
				int y1 = y-data->ySize()/2+1;
				if (x1<0) { x1*=-1; y1*=-1; }
				x1*=2;
				y1+=data->ySize()/2;
				emit probe(mx,-1,x-data->xSize()/2+1,y-data->ySize()/2+1,data->valueAtSafe(x1,y1));
			}
			else
				emit probe(mx,-1,x-data->xSize()/2,y-data->ySize()/2,data->valueAtSafe(x,y));
		}
		else emit(mouseMove(e));
	}
	return;
}
else if (e->state()&RightButton) {
	if (data->zSize()>1) {
		if (y-mdy==0 && x-mdx==0) return;
		angle.setAngle(angle.alt()-(y-mdy)/40.0,angle.az()-(x-mdx)/40.0,angle.phi());
		needupd=1;
		update();
		mdy=y;
		mdx=x;
		return;
	}
	else {
		setOrigin(originx-(x-mdx),originy+y-mdy);
		needupd=1;
		update();
		mdy=y;
		mdx=x;
	}
}
else {
}

}

void Image::hilight(int i) { 
	if (i<0 || i>=shapes.count()) { select.type=ImShape::NONE; return; }
	select.x0=(*shapes.at(i)).x0; 
	select.y0=(*shapes.at(i)).y0; 
	select.x1=(*shapes.at(i)).x1; 
	select.y1=(*shapes.at(i)).y1; 
	select.user=(*shapes.at(i)).user; 
	select.type=(*shapes.at(i)).type;
	select.color=green;
}

void Image::imageChanged() { 
if (!datar) { update(); return; }
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }
needupd=1;
emit imChanged(data);
update();
}

int Image::addShape(ImShape *s,int n) {
if (n<0) {
	shapes.append(s);
	return shapes.count()-1;
}
shapes.insert(n,s);
return n;
}

void Image::delShape(int n) {
shapes.remove(n);
}

void Image::clearShapes() {
shapes.clear();
}

ImShape *Image::shapeAt(int n) {
if (n<0||n>=shapes.count()) return NULL;
return shapes.at(n);
}

void Image::setOrigin(int x,int y) { 
if (!datar) return;
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

originx=x; 
originy=y; 
if (originx<0) originx=0;
if (originy<0) originy=0;
if (originx>data->xSize()*scale-width() && data->xSize()*scale-width()>0) 
	originx= data->xSize()*scale-width();
if (originy>data->ySize()*scale-height() && data->ySize()*scale-height()>0) 
	originy= data->ySize()*scale-height();
//printf("%d %d %d %d\n",originx,originy,width()-data->xSize(), height()-data->ySize());
needupd=1; 
update(); 
emit(moved(x,y));
}
