#ifndef UCONTROL_H
#define UCONTROL_H
#include "Control.h"
#include "EMData.h"
#include "SliceImage.h"

class ControlU : public Control
{ 
    Q_OBJECT

	EMData *data;
	EMData *seg;
	EMData *undoseg;
	SliceImage *layerview;
	
	EMData *layerd,*layersegd;
	int dim;

public:
    ControlU( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ControlU();

	void setData(EMData *);		// We assume control of the passed object
	void setSeg(EMData *);		// We assume control of the passed object
	EMData *getSeg();			// We keep ownership of the returned object
	
public slots:
    void newseg();
    void newlayer(int);
    void newrot(float);
    void newsegname();
    void newsegsel(int);
	void copydown();
	void copyup();
	void copyupdown();
	void newfillpix();
	void newfillthr();
    void newshowseg(int);
	void spotflood(int x,int y,int seg);	
    void doV5D();
    void newdrawrad();
	void doUndo();
	
	void refreshlayer();

	void Mreadimage();
	void Mreadseg();
	void Msaveseg();
	void Mquit();

	void Msavemask();
	void Msavemdata();
};

inline void ControlU::setData(EMData *d) { if (data) delete data; data=d; } 
inline void ControlU::setSeg(EMData *d) { if (seg) delete seg; seg=d; }

#endif // UCONTROL_H
