#include <stdio.h>
#include <math.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "util.h"

struct DATAOUT {
int type;
int len;
int status;
char data;
};

FILE *rtcom,*bgcom;		// fifos for reading commands from external programs
struct DATAOUT *share;	// shared memory segment for output to ext pgm
int bgpid;



main() {
int i;

appinit(argc,argv);

init();

if ((i=fork())==0) bg_run();
else {
	bgpid=i;
	rt_run();
}

cleanup();

}

void bg_run() {


}

void rt_run() {

}

void init() {
char fsp[MAXPATH];
char s[MAXPATH+50];
int mid;

// This is eman's directory
sprintf(fsp,"%s/.eman",getenv("HOME"));
if (access(fsp,R_OK|W_OK|X_OK)) mkdir(fsp);

// Open the 'real time' command fifo
sprintf(fsp,"%s/.eman/rtcom",getenv("HOME"));
rtcom=fopen(fsp,"r");
if (rtcom==NULL) {
	sprintf(s,"mkfifo %s/.eman/rtcom",getenv("HOME"));
	system(s);
	rtcom=fopen(fsp,"r");
	if (rtcom==NULL) error("Cannot create rtcom fifo.",ERR_EXIT);
}
	
// Open the 'background' command fifo
sprintf(fsp,"%s/.eman/bgcom",getenv("HOME"));
bgcom=fopen(fsp,"r");
if (bgcom==NULL) {
	sprintf(s,"mkfifo %s/.eman/bgcom",getenv("HOME"));
	system(s);
	bgcom=fopen(fsp,"r");
	if (bgcom==NULL) error("Cannot create bgcom fifo.",ERR_EXIT);
}

// make a shared memory block for output to other apps
mid=shmget((key_t)('EMAN'+getuid()),1<<22,IPC_CREAT);
share=shmat(mid,NULL,0);
}

void cleanup() {
int mid;
struct shmid_ds buf;

kill(bgpid,9);

// destroy the shared memory segment
mid=shmget((key_t)('EMAN'+getuid()),1<<22,0);
shmct(mid,IPC_RMID,&buf);
shmdt(share);

// close the command pipes
fclose(rtcom);
fclose(bgcom);
}
